/********************************** (C) COPYRIGHT *******************************
* File Name          : GPIO.C
* Author             : WCH
* Version            : V1.0
* Date               : 2020/07/06
* Description        : CH545 IO ýӿںGPIOжϺ  
*******************************************************************************/  
#include "GPIO.H"
#include "Debug.H"
#pragma  NOAREGS

/*******************************************************************************
* Function Name  : GPIO_Init
* Description    : GPIO˿ڳʼ
* Input          : PORTx:0~4
*                  PINx:λ,ÿλӦPortһ
*                  MODEx:
*                        0:ģʽû
*                        1:ģʽжԳսϴ
*                        2:©ָ֧룬û
*                        3:׼˫ģʽ(׼ 8051)©֧룬(Ĭģʽ)
* Return         : None
*******************************************************************************/
void GPIO_Init(UINT8 PORTx,UINT8 PINx,UINT8 MODEx)
{
  UINT8 Px_DIR_PU,Px_MOD_OC;
    
	switch(PORTx)                                       //ʼֵ
	{
		case PORT0:
				Px_MOD_OC = P0_MOD_OC;
				Px_DIR_PU = P0_DIR_PU;
				break;
		case PORT1:
				Px_MOD_OC = P1_MOD_OC;
				Px_DIR_PU = P1_DIR_PU;
				break;
		case PORT2:
				Px_MOD_OC = P2_MOD_OC;
				Px_DIR_PU = P2_DIR_PU;
				break;
		case PORT3:
				Px_MOD_OC = P3_MOD_OC;
				Px_DIR_PU = P3_DIR_PU;
				break;
		case PORT4:
				Px_MOD_OC = P4_MOD_OC;
				Px_DIR_PU = P4_DIR_PU;
				break;
		default :
				break;
	}
	
	switch(MODEx)
	{
		case MODE0:                                           //ģʽû
				Px_MOD_OC &= ~PINx;
				Px_DIR_PU &= ~PINx;
				break;
		case MODE1:                                           //ģʽжԳսϴ
				Px_MOD_OC &= ~PINx;
				Px_DIR_PU |= PINx;
				break;
		case MODE2:                                           //©ָ֧룬û
				Px_MOD_OC |= PINx;
				Px_DIR_PU &= ~PINx;
				break;
		case MODE3:                                           //׼˫ģʽ(׼ 8051)©֧룬
				Px_MOD_OC |= PINx;
				Px_DIR_PU |= PINx;
				break;
		default :
				break;
	}
	switch(PORTx)                                         //д
	{
		case PORT0:
				P0_MOD_OC = Px_MOD_OC;
				P0_DIR_PU = Px_DIR_PU;
				break;
		case PORT1:
				P1_MOD_OC = Px_MOD_OC;
				P1_DIR_PU = Px_DIR_PU;
				break;
		case PORT2:
				P2_MOD_OC = Px_MOD_OC;
				P2_DIR_PU = Px_DIR_PU;
				break;
		case PORT3:
				P3_MOD_OC = Px_MOD_OC;
				P3_DIR_PU = Px_DIR_PU;
				break;
		case PORT4:
				P4_MOD_OC = Px_MOD_OC;
				P4_DIR_PU = Px_DIR_PU;
				break;
		default :
				break;
	}
}

/*******************************************************************************
* Function Name  : GPIO_INT_Init
* Description    :  RXD1_LP15_LP14_LP03_LRXD0_LP0.0P0.7P1.0P1.3P2.0P2.3P4.0P4.7 չŵⲿж
*                  ͬʱC51 INT1_LINT0_L ⲿжϴ
*                  (RXD1_LRXD0_LĸȡǷӳ)
* Input          : IntSrc:9ⲿжϣλʾ嶨GPIO.H
*                  Mode0ƽģʽ   1ģʽ (עչŵжģʽͳһõ)
*                  NewState0رնӦⲿжʹ  1Ӧⲿж
* Return         : None
*******************************************************************************/
void GPIO_INT_Init( UINT16 IntSrc,UINT8 Mode,UINT8 NewState )
{
	/* жϴģʽ */
	if(IntSrc & 0x7F||IntSrc & 0xF000)              //չж
	{
		SAFE_MOD = 0x55;                                    //밲ȫģʽ
	  SAFE_MOD = 0xAA;
		if(Mode == INT_EDGE)                                //شģʽ
		{
			GPIO_IE |= bIE_IO_EDGE;
		}
		else                                                //ƽģʽ
		{
			GPIO_IE &= ~bIE_IO_EDGE;			
		}
		
	}
	
	if(IntSrc&INT_INT0_L)                           //ⲿж0
	{
		IT0 = 1;
	}
	if(IntSrc&INT_INT1_L)                           //ⲿж1
	{
		IT1 = 1;
	}
	
	SAFE_MOD = 0x55;                                    //밲ȫģʽ
	SAFE_MOD = 0xAA;	
	/* жʹ״̬ */
	if(NewState == Enable)                              //ⲿж
	{
		GPIO_IE |= ((UINT8)IntSrc&0x7F);
		if(IntSrc&INT_INT0_L)                           //ⲿж0
		{
			EX0 = 1;
		}
		if(IntSrc&INT_INT1_L)                           //ⲿж1
		{
			EX1 = 1;
		}
		if(IntSrc & 0xF000)
		{
			IntSrc = IntSrc/256;
			PORT_CFG |= (UINT8)IntSrc&0xFF;
		}
		IE_GPIO = 1;                                    //չGPIOж
		EA = 1;                                         //ж
	}
	else                                                //رնӦⲿж
	{
		GPIO_IE &= ~((UINT8)IntSrc&0x7F);
		if(IntSrc&INT_INT0_L)                           //ⲿж0
		{
			EX0 = 0;
		}
		if(IntSrc&INT_INT1_L)                           //ⲿж1
		{
			EX1 = 0;
		}
		if(IntSrc & 0xF000)
		{
			IntSrc = IntSrc/256;
			PORT_CFG |= ~(UINT8)IntSrc&0xFF;
		}
		IE_GPIO = 0;                                   //رչGPIOж   
	}
 
}

/*******************************************************************************
* Function Name  : GPIO_ISR
* Description    : P15P03P40P41ⲿжϷ
* Input          : None
* Return         : None
*******************************************************************************/
void GPIO_EXT_ISR(void) interrupt INT_NO_GPIO
{
	if(P0_3==0)
	{
		printf("P03 Falling\n");
	}
	
	if(P0_4==0)printf("0\n");
	else printf("1\n");
	
	if(P1_5==0)
	{
		printf("P15 Falling\n");
	}

	if(P4_0==0)
	{
		printf("P40 Falling\n");
	}

	if(P4_1==0)
	{
		printf("P41 Falling\n");
	}

}
/*******************************************************************************
* Function Name  : GPIO_STD0_ISR
* Description    : INT0(P32) ⲿжϷ
* Input          : None
* Return         : None
*******************************************************************************/
void GPIO_STD0_ISR(void) interrupt INT_NO_INT0
{	
	printf("P32 Falling\n");

}
/*******************************************************************************
* Function Name  : GPIO_STD1_ISR
* Description    : INT1(P33) ⲿжϷ
* Input          : None
* Return         : None
*******************************************************************************/
void GPIO_STD1_ISR(void) interrupt INT_NO_INT1
{
	printf("P33 Falling\n");

}
