/********************************** (C) COPYRIGHT *******************************
* File Name          : Debug.C
* Author             : WCH
* Version            : V1.0
* Date               : 2020/07/03
* Description        : This file contains all the functions prototypes for UART
*                      Printf , Delay functions.									 
*******************************************************************************/
#include "Debug.H"

/*******************************************************************************
* Function Name  : CfgFsys
* Description    : CH545ʱѡú,λĬʹڲFsys=12MHz
*                   FREQ_SYSͨCLOCK_CFGõõʽ£
*                   Fsys = (Fosc * 4/(CLOCK_CFG & MASK_SYS_CK_SEL);ʱҪԼ 
* Input          : None
* Return         : None
*******************************************************************************/ 
void CfgFsys(void)  
{
#if OSC_EN_XT	
	P7 = P7 & 0xF0 | 0x06;							  //ⲿǰ,P7.0ڵ͵ƽ,P7.1״̬
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	CLOCK_CFG |= bOSC_EN_XT;                          //ʹⲿ
	mDelaymS(10);
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	CLOCK_CFG &= ~bOSC_EN_INT;                        //رڲ 
	SAFE_MOD = 0x00;
#endif	
	
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
#if FREQ_SYS == 48000000	
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x07;  // 48MHz	
	
#endif	
	
#if FREQ_SYS == 32000000	
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x06;  // 32MHz	
	
#endif
	
#if FREQ_SYS == 24000000	
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x05;  // 24MHz	
	
#endif	

#if FREQ_SYS == 16000000		
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x04;  // 16MHz
	
#endif

#if FREQ_SYS == 12000000		
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x03;  // 12MHz
	
#endif	

#if FREQ_SYS == 3000000	
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x02;  // 3MHz
	
#endif

#if FREQ_SYS == 750000	
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x01;  // 750KHz
	
#endif

#if FREQ_SYS == 187500	
	CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x00;  // 187.5KHz	
	
#endif

	SAFE_MOD = 0x00;
}

/*******************************************************************************
* Function Name  : mDelayus
* Description    : usʱuSΪλʱ
* Input          : n
* Return         : None
*******************************************************************************/ 
void mDelayuS(UINT16 n)  
{
#ifdef	FREQ_SYS
#if		FREQ_SYS <= 6000000
		n >>= 2;
#endif
#if		FREQ_SYS <= 3000000
		n >>= 2;
#endif
#if		FREQ_SYS <= 750000
		n >>= 4;
#endif
#endif
	while(n){  // total = 12~13 Fsys cycles, 1uS @Fsys=12MHz
		++ SAFE_MOD;  // 2 Fsys cycles, for higher Fsys, add operation here
#ifdef	FREQ_SYS
#if		FREQ_SYS >= 14000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 16000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 18000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 20000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 22000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 24000000
		++ SAFE_MOD;
#endif
#endif
		-- n;
	}
}

/*******************************************************************************
* Function Name  : mDelayms
* Description    : msʱmSΪλʱ
* Input          : n
* Return         : None
*******************************************************************************/
void mDelaymS(UINT16 n)                                                    
{
	while(n){
		mDelayuS(1000);
		-- n;
	}
}                                         

/*******************************************************************************
* Function Name  : CH545UART0Alter
* Description    : CH5450ӳ,ӳ䵽P0.2P0.3
* Input          : None
* Return         : None
*******************************************************************************/
void CH545UART0Alter(void)
{
	PIN_FUNC |= bUART0_PIN_X;                                                 
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : CH5450ʼ,ĬʹT1ʷҲʹT2
*                   -T1UART0ĲʷRCLK=0TCLK=0
*                   -T2UART0ĲʷRCLK=1TCLK=1               
* Input          : None
* Return         : None
*******************************************************************************/
void mInitSTDIO(void)
{
	UINT32 x;
	UINT8 x2; 

	/* 0ʹģʽ1 */
	SM0 = 0;
	SM1 = 1;
	SM2 = 0;                                                                 
	
	/* ʹTimer1Ϊʷ */
	RCLK = 0;                                                                  //UART0ʱ
	TCLK = 0;                                                                  //UART0ʱ
	
	PCON |= SMOD;
	x = 10 * FREQ_SYS / UART0_BUAD / 16;                                       //ƵעxֵҪ                            
	x2 = x % 10;
	x /= 10;
	if(x2 >= 5) x++;                                                       //

	TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;              //0X20Timer1Ϊ8λԶضʱ
	T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                        //Timer1ʱѡ
	TH1 = 0-x;                                                                 //12MHz,buad/12Ϊʵò
	TR1 = 1;                                                                   //ʱ1
	TI = 1;
	REN = 1;                                                                   //0ʹ
}

/*******************************************************************************
* Function Name  : CH545UART0RcvByte
* Description    : CH545UART0һֽ
* Input          : None
* Return         : SBUF
*******************************************************************************/
UINT8 CH545UART0RcvByte(void)
{
	while(RI == 0);                                                            //ѯգжϷʽɲ
	RI = 0;
	return SBUF;
}

/*******************************************************************************
* Function Name  : CH545UART0SendByte
* Description    : CH545UART0һֽ
* Input          : SendDatҪ͵
* Return         : None
*******************************************************************************/
void CH545UART0SendByte(UINT8 SendDat)
{
	SBUF = SendDat;                                                              //ѯͣжϷʽɲ2,ǰTI=0
	while(TI == 0);
	TI = 0;
}

/*******************************************************************************
* Function Name  : CH545WDTModeSelect
* Description    : CH545Źģʽѡ
* Input          : mode
*                   0timer
*                   1watchDog
* Return         : None
*******************************************************************************/
void CH545WDTModeSelect(UINT8 mode)
{
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xaa;                                                             //밲ȫģʽ
	if(mode){
	 GLOBAL_CFG |= bWDOG_EN;                                                    //Źλ
	}
	else GLOBAL_CFG &= ~bWDOG_EN;	                                              //ŹΪʱ
	SAFE_MOD = 0x00;                                                             //˳ȫģʽ
	WDOG_COUNT = 0;                                                              //Źֵ
}

/*******************************************************************************
* Function Name  : CH545WDTFeed
* Description    : CH545Źι
*                  Źλʱ(s) = (256-tim)/(Fsys/131072)
*                  00H(Fsys=12MHz)=2.8s
*                  80H(Fsys=12MHz)=1.4s
* Input          : timŹֵ
* Return         : None
*******************************************************************************/
void CH545WDTFeed(UINT8 tim)
{
	WDOG_COUNT = tim;                                                             //Źֵ	
}

/*******************************************************************************
* Function Name  : CH545SoftReset
* Description    : CH545λ
* Input          : None
* Return         : None
*******************************************************************************/
void CH545SoftReset(void)
{
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	GLOBAL_CFG |= bSW_RESET;
}

